#!/usr/bin/perl

package main;
use strict;
use integer;

require './ini.pl';
require './std.pl';

############ ԥѥ ##############
my $ADMINPASS = 'onigiri';
######################################

my $CTRL;
my %FORM;
my @DAT = ();


##---------------
## main

&std::head_out;
if ( &read_form ) {
	&add_member    if $CTRL eq 'a';
	&delete_member if $CTRL eq 'd';
	&table_out;
} else {
	&form_out;
}
&std::footer_out;
exit;


##---------------

## add_member
sub add_member {
	my $key = &std::crypt_key( $FORM{'pass'}, $FORM{'username'} );
	open( FILE, "+<$ini::MEMFILE" ) or &std::err(1);
	flock( FILE, 2 );
	@DAT = <FILE>;
	( $_, undef ) = split( /\t/, $DAT[-1] );
	$_++;
	push ( @DAT, "$_\t$FORM{'username'}\t$key\n" );
	seek( FILE, 0, 0 );
	print FILE @DAT;
	truncate( FILE, tell );
	close FILE;
}

## delete_member
sub delete_member {
	open( FILE, "+<$ini::MEMFILE" ) or &std::err(1);
	flock( FILE, 2 );
	@DAT = <FILE>;
	foreach ( 0 .. @DAT - 1 ) {
		( my $num , undef ) = split( /\t/, $DAT[$_] );
		splice( @DAT, $_, 1 ) if $FORM{'number'} eq $num;
	}
	seek( FILE, 0, 0 );
	print FILE @DAT;
	truncate( FILE, tell );
	close FILE;
}

## form_out
sub form_out {
	print  <<HTML;
<form action="$ini::ADMINCGIURL" method="POST">
<p>
Admin Password : <input type="password" name="admin" size="10">
<input class="button" type="submit" value="Submit">
</p>
</form>
HTML
}

## table_out
sub table_out {
	print  <<HTML;
<form action="$ini::ADMINCGIURL" method="POST">
<p>
<input type="hidden" name="m" value="a">
<input type="hidden" name="admin" value="$FORM{'admin'}">
Username : <input type="text" name="username" size="15">
Password : <input type="password" name="pass" size="10">
<input class="button" type="submit" value="Add Member">
</p>
</form>

<form action="$ini::ADMINCGIURL" method="POST">
<input type="hidden" name="admin" value="$FORM{'admin'}">
<input type="hidden" name="m" value="d">
HTML

	my $header = <<HTML;
<table summary="Member List" border="1" cellspacing="0" class="memberlist"><tbody>
	<tr class="tablehead"><th>No.</th><th>Name</th><th>Delete</th></tr>
HTML

	my $footer = <<HTML;
</tbody></table>
HTML

	open( FILE, "<$ini::MEMFILE" ) or &std::err(1);
	@DAT = <FILE>;
	my $par = @DAT / 3 + 1;
	print $header;
	foreach ( 0 .. @DAT - 1 ) {
		my ( $num, $name, undef ) = split( /\t/, $DAT[$_] );
		print qq!\t<tr><td>$num</td><td>$name</td><td><input type="radio" name="number" value="$num"></td></tr>\n!;
		print $footer . $header if ( $_ and !(($_ + 1) % $par) and $_ != @DAT - 1 );
	}
	close FILE;

	print <<HTML;
</tbody></table>
<p style="clear : both;"><input class="button" type="submit" value="Delete Member"></p>
</form>
HTML

}

## read_form
sub read_form {
	&std::err(6) if ( $ENV{'CONTENT_LENGTH'} > 512 );
	my ( $buffer, $name, $value, $pair );
	my @pairs;
	read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );
	return 0 unless $buffer;
	@pairs = split( /&/, $buffer );
	my %tmp;
	foreach $pair ( @pairs ) {
		$pair =~ tr/+/ /;
		( $name, $value ) = split( /=/, $pair );
		$value =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("c", hex($1))/ge;
		$tmp{$name} = $value;
	}

	return 0 if $tmp{'admin'} ne $ADMINPASS;

	$FORM{'admin'} = $tmp{'admin'};
	$CTRL = $tmp{'m'};
	$CTRL = undef unless $CTRL =~ /^[ad]{1}$/;

	if ( $CTRL eq 'a' ) {
		&std::err(12) unless &_chk_pwd( $tmp{'pass'}, 3, 8 );
		&std::err(13) unless &_chk_pwd( $tmp{'username'}, 3, 10 );
		$FORM{'username'} = $tmp{'username'};
		$FORM{'pass'} = $tmp{'pass'};
	} elsif ( $CTRL eq 'd' ) {
		&std::err(14) unless $tmp{'number'} =~ /^\d+$/;
		$FORM{'number'} = $tmp{'number'};
	}
	return 1;
}

sub _chk_pwd {
	my $pass = shift;
	my $min = shift;
	my $max = shift;
	return 0 if $pass eq undef;
	$_ = length( $pass );
	return 0 if ( $pass =~ /[^a-zA-Z0-9]/ or $min > $_ or $max < $_ );
	return 1;
}
